#include "oxt.h"

/* clipboard */
struct{
	void*data;
	int wdt,hgt,ct;
}clip={NULL,0,0,0};

/***************** tABLE hANDLiNG rOUTiNES ********************/

void inscol(int n) /* insert new column at #n */
{
	int i;
	tablesize++;
	for(i=tablesize-1;i>=n;i--)
		memcpy(&columns[i+1],&columns[i],sizeof(columndef));
	es.worthredraw=3;/* paitsi jos tablen loppuun */
}

void delcol(int n) /* delete column from #n */
{
	if(columns[n].celltype==Trackcell)
		packtrack(columns[n].patt,columns[n].chan);
	tablesize--;
	for(;n<tablesize;n++)
		memcpy(&columns[n],&columns[n+1],sizeof(columndef));
	es.worthredraw=3;
}

void setcol(int n,int ct,int p,int c)
{
	columndef*co=&columns[n];
	co->celltype=ct;
	co->width=celltypes[ct].scrsize;
	switch((int)ct){
		case(Trackcell):
			co->data=(void*)gettrack(p,c);
			co->height=trax[p][c].lgt;
			co->patt=p;
			co->chan=c;
			break;
		case(Ordercell):
			co->data=(void*)order;
			co->height=MAXORDER;
			break;
		case(Samplecell):
			co->data=(void*)sample;
			co->height=MAXSMPS;
			break;
	}
}

/********************************/

int e_getpattern() /* the id# of current visible pattern */
{
	if(columns[es.col].celltype==Trackcell)
		return columns[es.col].patt;else
	{
		int c=0;
		for(;c<tablesize;c++){
			if(columns[c].celltype==Trackcell)
				return columns[c].patt;
		}
		return 0;
	}
}

void e_resort_columns()
{
	int i,pat=e_getpattern();
	es.col=es.row=es.fld=es.chr=tablesize=es.brow0=0;
	es.brow1=-1;
	pack_all();
	tablesize=getnumch();
	for(i=0;i<tablesize;i++)setcol(i,Trackcell,pat,i);

	e_mvcrs(4);
	drawheadframe(0);
}

void e_jump_chan(int n,int here) /* e_jump_* => e_jump */
{
	int c=0;
	for(;c<tablesize;c++)
		if(columns[c].celltype==Trackcell)
		if(columns[c].chan==n){
		if(!here){es.col=c;return;}else delcol(c);
		break;}

	inscol(es.col);setcol(es.col,Trackcell,e_getpattern(),n);
	es.fld=es.chr=0;
}

void e_jump_order(int here)
{
	int c=0;
	for(;c<tablesize;c++)
		if(columns[c].celltype==Ordercell){
		if(!here){es.col=c;return;}else delcol(c);
		break;}
	inscol(es.col);setcol(es.col,Ordercell,0,0);
	es.fld=es.chr=0;
}

void e_jump_samples(int here)
{
	int c=0;
	for(;c<tablesize;c++)
		if(columns[c].celltype==Samplecell){
		if(!here){es.col=c;return;}else delcol(c);
		break;}
	inscol(es.col);setcol(es.col,Samplecell,0,0);
	es.fld=es.chr=0;
}

void e_patternjump(int nr)
{
	int c=0;
	if(nr<0){
	for(;c<tablesize;c++)
		if((columns[c].celltype==Trackcell)&&
		  (columns[c].patt<0-nr))nr=0-columns[c].patt;
	c=0;
	}
	if(nr){
	for(;c<tablesize;c++)
	if(columns[c].celltype==Trackcell){
		columns[c].patt+=nr;
		columns[c].data=(void*)gettrack(columns[c].patt,columns[c].chan);
	}
	e_mvcrs(2);
	drawheadframe(0);
	}
}

void e_jump(char*s)
{
	char*p=s;int n=0;char t='p';int here=0;

	for(;;){
		if((*p>='0')&&(*p<='9'))n=(n<<4)|(*p-'0');else
		if((*p>='A')&&(*p<='F'))n=(n<<4)|(*p-'A'+0xa);else
		if((*p>='a')&&(*p<='f'))n=(n<<4)|(*p-'a'+0xa);else{
		switch((int)t)
		{
			case('z'):delcol(es.col);e_mvcrs(3);break;
			case('h'):here=1;break;
			case('p'):if(p!=s)e_patternjump(n-e_getpattern());break;
			case('.'):e_jump_chan(n,here);break;
			case('i'):es.inst=n;break;
			case('r'):if(n<columns[es.col].height)es.row=n;break;
			case('o'):e_jump_order(here);break;
			case('s'):e_jump_samples(here);break;
			case('t'):e_resort_columns();break;
			default:e_print("got unknown");break;
		}n=0;t=*p;}
		if(!*p)break;
		p++;
	}
}

/*********************** block processor ***********************/

typedef struct{
	void*valu,*empty;int size;int ml;
	int flags;
	signed int add,mul,div,equ,intp;
	int step,crit;
	int clipuse;
	int blockuse;
}procpar;

#define PROC_FILLER 1
#define PROC_FILL   2
#define PROC_ARITHM 4
#define PROC_DEL    8
#define PROC_INS    16

#define PROCBLK_AREA  0
#define PROCBLK_CELL  1
#define PROCBLK_ROW   2
#define PROCBLK_WHOLE 3

void e_process_del(int c0,int y,int rn,void*valu,int cs)
{
	int mh=columns[c0].height;
	void*d=columns[c0].data;

	for(;y<=mh;y++)
		if(y>=mh-rn)memcpy(d+cs*y,valu,cs);
		else memcpy(d+cs*y,d+cs*(y+rn),cs);
}

void e_process_ins(int c0,int r0,int rn,void*valu,int cs)
{
	int y=r0,mh=columns[c0].height,y1=mh;
	void*d=columns[c0].data;
	if(y1>=mh-rn)y1=mh-rn-1;

	for(;y1>=y;y1--)memcpy(d+cs*(y1+rn),d+cs*y1,cs);
		
	y1=r0+rn-1;
	for(y=r0;y<=y1;y++)memcpy(d+cs*y,valu,cs);
}

int e_process_testcrit(void*s,procpar*p)
{
	int ret;
	int tst=memcmp(s,p->empty,p->size)?2:1;

	if((p->crit&3)&tst)ret=1;else ret=0;

	if(p->crit&4){
		if(tst==1)p->crit=4;else p->crit=4|1;
	}
	return ret;
}

void e_process_par(procpar*p)
{
	int c0=es.col,c1,r0,r1,i,skipped=0;
	int ct=columns[es.col].celltype,cs=celltypes[ct].memsize;
	void*clpd=clip.data+p->ml;

	switch((int)p->blockuse){	
		case(PROCBLK_AREA):default:
			r0=es.brow0;r1=es.brow1;
			c0=es.bcol0;c1=es.bcol1;break;
		case(PROCBLK_ROW):
			r0=es.row;r1=r0+p->step-1;
			c0=0;c1=tablesize-1;break;
		case(PROCBLK_CELL):
			r0=es.row;r1=r0+p->step-1;
			c1=c0;break;
		case(PROCBLK_WHOLE):
			r1=columns[c0].height;
			r0=c0=0;c1=tablesize-1;break;
	}

	if(r1<r0){
		c0=c1=es.col;r0=0;r1=columns[es.col].height;
		r0+=((r0-es.row)%p->step);
	}

	if(p->clipuse&2){ /* init new clipboard */
		if(clip.data!=NULL)free(clip.data);
		clpd=clip.data=malloc(cs*(c1-c0+1)*(r1-r0+1));
		clip.wdt=0;clip.hgt=r1-r0+1;clip.ct=ct;
	}else
	if(p->clipuse&1){
		c0=es.col;
		c1=c0+clip.wdt-1;
		r0=es.row;		
		r1=r0+(clip.hgt-1)*p->step;
		if(clip.ct!=ct){e_print("type mismatch");return;}
	}

	p->valu+=p->ml;
	p->empty+=p->ml;

	for(;c0<=c1;c0++){
		void*d=columns[c0].data+p->ml;
		int mh=columns[c0].height;	 	

		if(c0>=tablesize)break;

	 	if(columns[c0].celltype!=ct)skipped++;else
	 	{

	 	if(p->clipuse&2)clip.wdt++;
		if(p->crit&4)p->crit&=4;

		/* ins/del */
		if(p->flags&PROC_DEL)
			e_process_del(c0,r0,r1-r0+1,celltypes[ct].dflt,cs);else
		if(p->flags&PROC_INS)
			e_process_ins(c0,r0,r1-r0+1,celltypes[ct].dflt,cs);

	 	/* fill/copy => separate func? */
	 	if(p->flags&PROC_FILLER)
	 	for(i=r0;i<=r1;i+=p->step){
	 		void*va;
	 		if(i>=mh){
	 			if(p->clipuse){
	 				if(p->clipuse&2)memcpy(clpd,celltypes[ct].dflt,cs);
	 				clpd+=cs;
	 			}
	 			else break;
	 		}else{

			va=p->valu;
			if(p->clipuse){
	 			if(p->clipuse&2) /* copy to clipboard */
	 				memcpy(clpd,d+cs*i-p->ml,cs);
		 		else
		 			va=clpd;
		 		clpd+=cs;
		 	}

			if(p->flags&PROC_FILL)
			if(e_process_testcrit(d+cs*i,p))
	 		memcpy(d+cs*i,va,p->size);
	 		}
	 		}

	 	/* arithmetic => separate func? */
	 	
	 	if(p->flags&PROC_ARITHM)
	 	if(p->size==sizeof(char)){
	 	if(p->div==0)e_print("no such bug");else
	 	for(i=r0;i<=r1;i+=p->step){
	 		uchar*z=(uchar*)(d+cs*i);
	 		int equ;
	 			if(p->equ>=0)equ=p->equ+((i-r0)*(p->intp-p->equ))/(r1-r0);
	 			else equ=*z;
	 		if(i>=mh)break;
			if(e_process_testcrit(d+cs*i,p))
	 			if(equ!=0xff)*z=((equ+p->add)*p->mul)/p->div;	 			
	 	}}

	 } }
	 if(p->flags&(PROC_ARITHM|PROC_FILL|PROC_INS|PROC_DEL))e_mvcrs(2);
	 if(skipped)e_print("skipped incompatible columns");
	 	else e_print("processed");
	 doupdate();
}

/*

	ijk szp rn>#t +-*=/:#

	

	+-*=/: 0..f o == arithmetic
	r n > 0..f t  == cell selectors
	s z           == set/zap

	p             == paste (get "p->valu") from clipboard
	k             == copy to clipboard before doing anything
	i j           == insert/delete space before doing anything
*/

void e_process(char*s)
{
	const celldef*ct=&celltypes[columns[es.col].celltype];
	procpar par={ct->dflt,ct->dflt,ct->memsize,0,
		0,
		0,1,1,-1,-1,
		1,3,
		0,
		PROCBLK_AREA};
	char t='\0';int n=0;

	if(s==NULL){
		s=malloc(20*sizeof(char));
		e_print("z=clear s=set +-*/=arithm; t=this fld only "
		        "n/r=(non)reserved flds only");
		        /* nm ui-koodiin => .oxtrc:hen */
		e_getstring(s,20);
	}
	if(!*s)return;
	for(;;){
		if((*s>='0')&&(*s<='9'))n=(n<<4)|(*s-'0');else
		if((*s>='a')&&(*s<='f'))n=(n<<4)|(*s-'a');else
		if(*s=='o')n*=12;else
		{
		switch((int)t){
			case('\0'):if(n)par.step=n;break;
			case('+'):par.add+=n;break;
			case('-'):par.add-=n;break;
			case('*'):par.mul*=n;break;
			case('/'):par.div*=n;break;
			case('='):par.equ=par.intp=n;break;
			case(':'):par.intp=n;break;
		}
		n=0;
		if(!*s)break;
		switch((int)*s){
		case('r'):
			par.crit=1;break;
		case('n'):
			par.crit=2;break;
		case('>'):
			par.crit=4;break;
		case('z'):
			par.flags|=PROC_FILLER|PROC_FILL;
			par.valu=par.empty;break;
		case('s'):
			par.flags|=PROC_FILLER|PROC_FILL;
			par.valu=columns[es.col].data+ct->memsize*es.row;break;
		case('+'):case('-'):case('*'):case('/'):case('='):case(':'):
			t=*s;
			par.flags|=PROC_ARITHM;
		case('t'):
			par.size=ct->fields[es.fld].memsize;
			par.ml=ct->fields[es.fld].memloc;break;
		case('k'):
			par.flags|=PROC_FILLER;
			par.clipuse=2;break;
		case('p'):
			par.flags|=PROC_FILLER|PROC_FILL;
			par.clipuse=1;break;
		case('i'):
			par.flags|=PROC_INS;break;
		case('j'):
			par.flags|=PROC_DEL;break;
		case('R'):
			par.blockuse=PROCBLK_ROW;break;
		case('C'):
			par.blockuse=PROCBLK_CELL;break;
		case('W'):
			par.blockuse=PROCBLK_WHOLE;break;
		}
	}s++;}
	e_process_par(&par);
}

/*****************************************************************/

void e_editor() /* -> .oxtrc controlled */
{
	int c;

	for(;;){
		void*thiscell;

		e_mvcrs(0);
		
		thiscell=columns[es.col].data+
		celltypes[columns[es.col].celltype].memsize*es.row;

		c=e_getcmd();
		switch((int)c){
			case(cQuit):return;
			case(cClearInsts):
				init_instruments();e_jump("t");break;
			case(cClearTracks):
				init_tracks();e_jump("t");break;
			case(cClearSong):
				init_song();e_jump("t");break;
	
			case(cUp):es.row--;break;
			case(cDown):es.row++;break;
			case(cUp16):es.row-=16;break;
			case(cDown16):es.row+=16;break;
			case(cTop):es.row=0;break;
			case(cBottom):es.row=columns[es.col].height;break;
			case(cPrevField):es.col--;break;
			case(cNextField):es.col++;break;
			case(cLeft):es.chr--;
				if(es.mode&em_Text)es.chr=-1;break;
			case(cRight):es.chr++;
				if(es.mode&em_Text)es.chr=99;break;


			case(cNextOctave):if(es.oct<9){es.oct++;updateheadframe();}break;
			case(cPrevOctave):if(es.oct>0){es.oct--;updateheadframe();}break;

			case(cNextInst):if(es.inst<31){es.inst++;updateheadframe();}break;
			case(cPrevInst):if(es.inst>0){es.inst--;updateheadframe();}break;

			case(cNextPattern):e_patternjump(1);break;
			case(cPrevPattern):e_patternjump(-1);break;
			case(cRedraw):
				e_mvcrs(4);/*drawheadframe(es.col0);*/
				redrawwin(w);
				e_print("screen redrawn!");
				break;

			case(cJump):{
				char s[20];
				e_print("jump [pat#]/.[chn#]/i[ns#]/r[ow#] (s)mpls (o)rd"
				        " /z)ap h)ere resor(t)");
				e_getstring(s,20);
				e_jump(s);
				wrefresh(w1);
				e_mvcrs(0);
			}break;
			case(cJumptoOrder):
				e_jump("o");
			break;
			case(cResortColumns):
				e_jump("t");
			break;
			case(cJumptoSamples):
				e_jump("s");
			break;

			/*** mark block ***/

			case(cBeginBlock):
				if(es.bcol0==es.bcol1)es.bcol1=es.col;
				es.brow0=es.row;es.bcol0=es.col;e_mvcrs(2);
				break;
			case(cEndBlock):  es.brow1=es.row;es.bcol1=es.col;e_mvcrs(2);break;
			case(cUnmarkBlock):es.brow1=es.bcol1=-1;e_mvcrs(2);break;
			case(cMarkEntireColumn):
				es.brow0=0;es.brow1=63;
				es.bcol0=es.bcol1=es.col;
				e_mvcrs(2);
			break;
			case(cMarkEntireTable):
				es.brow0=es.bcol0=0;
				es.bcol1=tablesize;
				es.brow1=63; /* vaihda => matalimman kolumnin korkeus */
				e_mvcrs(2);
			break;

			/*** block processor ***/

		case(cCopyBlock):e_process("k");break;
		case(cPasteBlock):e_process("p");break;
		case(cInsOne):e_process("Ci");break;
		case(cDelOne):e_process("Cj");break;

		case(cClearAll):e_process("z");break;
		case(cClearThis):e_process("zt");break;
		case(cFillAll):e_process("s");break;
		case(cFillThis):e_process("st");break;
		/* ^^ noista tulee viela obsoliitteja kun saadaan makrot */

		case(cProcess):e_process(NULL);break;

		case(cFileFuncs):
			if(columns[es.col].celltype==Samplecell){
				e_print("sample: r)ead w)rite d)elete / convert s)ign");
				switch((int)(c=e_getch(w1))){
				case('r'):
					read_sample(&sample[es.row],e_getfilename());
					e_mvcrs(1);break;
				case('w'):
					write_sample(&sample[es.row],e_getfilename());break;
				case('d'):
					delete_sample(&sample[es.row]);e_mvcrs(1);break;
				case('s'):
					convsmp(&sample[es.row],"s");
					e_print("sign converted");break;
				}
			}else{
				e_print("song: r=read w=write");
				c=e_getch(w1);
				if(c=='r')read_song(e_getfilename());else
				if(c=='w')write_song(e_getfilename());
			}
		break;

	/******/
	
		case(cPlaySong):
			plr_playsong();
			e_print("playing song");
			es.playing=1;
			updateheadframe();break;
		case(cPlayPattern):
			plr_playpattern(e_getpattern());
			e_print("playing pattern");
			es.playing=1;
			updateheadframe();break;
		case(cPlayStop):
			plr_stop();
			e_print("stopped");
			es.playing=0;
			updateheadframe();break;
	}

	/************/

		if((c&~0xff)==cNumeric){
			int nn=c&0xff;
			const fielddef*f=&celltypes[columns[es.col].celltype].fields[es.fld];
			int ml=f->memloc;
			if(f->type==ByteFld){
				uchar*c=((uchar*)thiscell)+ml;
				if(nn==0xff){*c=0xff;e_mvcrs(1);es.row++;}else{
				if(es.chr==0){*c=(*c&~0xf0)|(nn<<4);e_mvcrs(1);es.chr++;}else
					{*c=(*c&~0xf)|nn;e_mvcrs(1);es.chr--;es.row++;}
					}
			}else{
			uint*c=(uint*)(((uchar*)thiscell)+ml);
			if(nn==0xff){*c=0;e_mvcrs(1);es.row++;}else{
				int sft=(f->size-es.chr-1)<<2;
				*c=(*c&(~0xf<<sft))|(nn<<sft);
				e_mvcrs(1);
				es.chr++;
				}
			}
			e_mvcrs(1);
			if(es.chr==f->size){es.row++;es.chr=0;}
		}else
		if((c&~0xff)==cChar){
			int nn=c&0xff;
			const fielddef*f=&celltypes[columns[es.col].celltype].fields[es.fld];
			int ml=f->memloc;
			uchar*c=((uchar*)thiscell)+ml;

			if(f->size==1){
				if((nn==0xff)||(nn<'0'))nn='0';
				*c=nn;
				e_mvcrs(1);
				es.row++;
			}else{
				int i=strlen(c);
				if(nn!=0xff){
				if(i>=f->size-1)i--;
				c[i]=nn;
				c[i+1]='\0';
				e_mvcrs(1);
				}else if(i){
				c[i-1]='\0';i-=2;
				e_mvcrs(1);
				}
				es.chr=i+1;
			}
		}else
		if(((c&~0xff)==cNote)||((c&~0xff)==cInst)){
			int nn=c&0xff;

			if(nn==0xff){
				((trackcellT*)thiscell)->note=0xff;
				((trackcellT*)thiscell)->ins=0xff;
			}
			else{
				int note,inst;
				if((c&~0xff)==cNote)
				    {note=nn+12*es.oct;inst=es.inst;}
				else{note=12*es.oct;inst=nn;}
				((trackcellT*)thiscell)->note=note;
				((trackcellT*)thiscell)->ins=inst;

				plr_setchan(0,&sample[inst],note);
				plr_wake();
				es.playing=1;
			}
			e_mvcrs(1);
			es.row++;
			}
	}
}
