#include "oxt.h"

/* mod tables */

int finetune[16] =
{   8363,   8413,   8463,   8529,   8581,   8651,   8723,   8757,
    7895,   7941,   7985,   8046,   8107,   8169,   8232,   8280 };

int npertab[60] =
{
    1712,1616,1524,1440,1356,1280,1208,1140,1076,1016,960,906,
    856,808,762,720,678,640,604,570,538,508,480,453,
    428,404,381,360,339,320,302,285,269,254,240,226,
    214,202,190,180,170,160,151,143,135,127,120,113,
    107,101,95,90,85,80,75,71,67,63,60,56
};

/***************************/

int fgetle2(FILE*f)
{
	return fgetc(f)+(fgetc(f)<<8);
}
int fgetle4(FILE*f)
{
	return fgetle2(f)+(fgetle2(f)<<16);
}

void fputle2(int c,FILE*f)
{
	fputc(c&0xff,f);
	fputc(c>>8,f);
}

void fputle4(int c,FILE*f)
{
	fputle2(c&0xffff,f);
	fputle2(c>>16,f);
}

/*******/

int read_raw(sampleT*s,FILE*f)
{
	int i=0;char*d;

	fseek(f,0,SEEK_SET);
	while(!feof(f)){fgetc(f);i++;}
	if(!i)return 0;

	fseek(f,0,SEEK_SET);
	d=s->data=malloc(i*sizeof(char));
	s->length=s->alloc=i;
	for(;i;i--)*d++=fgetc(f);

	s->loopstart=s->loopend=0;
	s->freq=8363;s->volume=0x40;
	s->format='b';s->looping='0';

	e_print("read: raw sample (signed 8-bit)\n");

	return 1;
}

int read_mod(FILE*f)
{
	int i,numpat,numch,orderlgt;

	fseek(f,0x438,SEEK_SET);
	{
		char tmp[4];
		numch=0;
		fread(tmp,1,4,f);
		     if(!memcmp(tmp,"M.K.",4))numch=4;
		else if(!memcmp(tmp,"6CHN",4))numch=6;
		else if(!memcmp(tmp,"8CHN",4))numch=8;
		else return 0;
	}
	fseek(f,0,SEEK_SET);

	songinfo.format=FMAT_MOD;

	if(!init_song())return 0;

	fread(songinfo.name,1,20,f);
	
	for(i=0;i<31;i++){
		fread(sample[i].name,1,22,f);
		sample[i].alloc=sample[i].length=((fgetc(f)<<8)+fgetc(f))<<1;
		sample[i].freq=finetune[fgetc(f)&0xf];
		sample[i].volume=fgetc(f);
		sample[i].loopstart=((fgetc(f)<<8)+fgetc(f))<<1;
		sample[i].loopend=sample[i].loopstart+( ((fgetc(f)<<8)+fgetc(f))<<1);
		if((!sample[i].loopstart)&&(sample[i].loopend==2))sample[i].looping='0';
			else sample[i].looping='1';
		if(sample[i].length)sample[i].format='b';else{
			sample[i].loopend=sample[i].freq=0;}
	}

	orderlgt=fgetc(f);
	fgetc(f);	/* magic 1 */
	numpat=0;
	for(i=0;i<128;i++){
		order[i].pattno=fgetc(f);
		if(numpat<order[i].pattno)numpat=order[i].pattno;
	}
	numpat++;
	for(i=orderlgt;i<128;i++)order[i].pattno=0xff;

	for(i=4;i;i--)fgetc(f); /* magic 2 -- tutki kanavamr! */

	for(i=0;i<numpat;i++){
	int r,c;trackcellT*tr[4];
	for(c=0;c<4;c++)tr[c]=gettrack(i,c);
	
	for(r=0;r<64;r++)
	for(c=0;c<numch;c++){
		char b,smpnum,fx,fxb;int period,note;
		trackcellT*t=&tr[c][r];
		
	/* read data */
		b=fgetc(f);smpnum=b&0xf0;period=(b&0xf)<<8;
		period|=fgetc(f);		
		b=fgetc(f);smpnum|=(b>>4)&0xf;fx=b&0xf;
		fxb=fgetc(f);
		
	/* note */
		if(period){
		for(note=0;note<60;note++)if(period>=npertab[note])break;
		t->note=note+24;}else t->note=0xff;

	/* instrument */
		t->ins=(smpnum-1)&0xff;

	/*	effects */
		if(fx==0xc)t->vol=fxb;else{	
		if(fx<0xa)t->fx='0'+fx;else t->fx='A'+fx-0xa;
		t->fxb=fxb;}		
	}
	}

	for(i=0;i<31;i++)if(sample[i].length){
		char*d=sample[i].data=malloc(sample[i].length*sizeof(char));
		fread(d,2,sample[i].length>>1,f);
	}
	
	e_print("read: protracker module");

	return 1;
}

int read_s3m(FILE*f)
{
	int inst_pp[64],pat_pp[256];
	int songlgt,numinst,numpat,defpan=0;

	fseek(f,0x2c,SEEK_SET);
	{
		char tmp[4];
		fread(tmp,1,4,f);
		if(memcmp(tmp,"SCRM",4))return 0;
	}
	fseek(f,0,SEEK_SET);

	songinfo.format=FMAT_S3M;

	if(!init_song())return 0;

	fread(songinfo.name,1,28,f);
	
	fseek(f,4,SEEK_CUR); /* 0x1a 16 exp exp */

	songlgt=fgetle2(f);
	numinst=fgetle2(f);
	numpat =fgetle2(f);

	fseek(f,0x30,SEEK_SET); /* flags 0x1320 samplesign SCRM etc */

	songinfo.globvol=fgetc(f);
	songinfo.initspd=fgetc(f);
	songinfo.inittmp=fgetc(f);
	songinfo.stereo=(fgetc(f)&128)?1:0;
	fgetc(f); /* ultraclick removal	*/
	defpan=fgetc(f); /* default panning (if ==252 ==0xfc)*/

	fseek(f,0x40,SEEK_SET);

/* chaninfo */
	{int i=0;
	for(;i<32;i++){
		uchar c=fgetc(f);
		chaninfo[i].enabled=(c&16)?0:1;
/*		chaninfo[i].panning=c&15;*/
		}
	}

/*	order */
	{int i=numpat=0;
	for(;i<songlgt;i++){
		uchar c=fgetc(f);
		order[i].pattno=c;
		if((c<254)&&(c>numpat))numpat=c;
	}}
	numpat++;

/* inst&patt pointers */
	{int i=0;
	for(;i<numinst;i++)inst_pp[i]=fgetle2(f);
	for(i=0;i<numpat;i++)pat_pp[i]=fgetle2(f);
	}

/* panning */
	if(defpan==0xfc){
		int i=0;
		for(;i<32;i++)chaninfo[i].panning=fgetc(f)&0xf;
	}
/*	if(!songinfo.stereo){
		int i=0;
		for(;i<32;i++)chaninfo[i].panning=8;
	}*/

/* instrument info */
	{int i=0;
	for(;i<numinst;i++){
		int dp;	
		fseek(f,0xd+(inst_pp[i]<<4),SEEK_SET);

/*		fgetc(f);		*/
		sample[i].format='b';/*else sample[i].format='?';*/

/*		dp=(fgetc(f)<<16)+(fgetc(f))+(fgetc(f)<<8);*/
		dp=((fgetc(f)<<16)+fgetle2(f))<<4;
		sample[i].length=sample[i].alloc=fgetle4(f);
		sample[i].loopstart=fgetle4(f);
		sample[i].loopend=fgetle4(f);
		sample[i].volume=fgetc(f);
		fgetle2(f); /* unused // packing*/
		sample[i].looping='0'+(fgetc(f)&1);
		
		sample[i].freq=fgetle4(f);
		fseek(f,12,SEEK_CUR);
		fread(sample[i].name,1,28,f);
		/* SCRS label*/
		
		fseek(f,dp,SEEK_SET);
		sample[i].data=malloc(sample[i].length*sizeof(char));
		fread(sample[i].data,1,sample[i].length,f);
		convsmp0(sample[i].data,sample[i].length,"s");
		
	}	}

/* patterns */
	{
	trackcellT*tr[32];
	int i=0;
	for(;i<numpat;i++){
	
		int ch,row=0;char b;
		
		fseek(f,2+(pat_pp[i]<<4),SEEK_SET);

		for(ch=0;ch<32;ch++)tr[ch]=gettrack(i,ch);
		/* packtrack?*/
		
		while(row<64){
			b=fgetc(f);
			if(!b)row++;else{
			trackcellT*t=&tr[b&31][row];
			if(b&32){
				int n=fgetc(f);if(n<0xfe)t->note=((n>>4)*12)+(n&0xf);
				t->ins=(fgetc(f)-1)&0xff;
				}
			if(b&64)t->vol=fgetc(f);
			if(b&128){int fx=fgetc(f);				
				t->fxb=fgetc(f);
				if(!fx){t->fx='0';t->fxb=0;}else t->fx='a'-1+fx;
				}
		}}

	}	}

	e_print("read: scream tracker 3 module");

	return 1;
}

void write_mod(FILE*f)
{
	int numpat,numch,i;
	int err;
	fwrite(songinfo.name,1,20,f);

	err=0;
	for(i=0;i<31;i++){
		int j;
		fwrite(sample[i].name,1,22,f);
		{
			int lgt=sample[i].length;
			if(lgt&1)err++;
			if(lgt>=65536)err++;
			fputc(lgt>>9,f);fputc((lgt>>1)&0xff,f);
		}

		for(j=0;j<16;j++)
			if(finetune[j]==sample[i].freq)break;
		if(j==16)err++;
		fputc(j&0xf,f);

		fputc(sample[i].volume,f);

		{
			int lgt=sample[i].loopstart;
			if(lgt&1)err++;
			if(lgt>65536)err++;
			fputc(lgt>>9,f);fputc((lgt>>1)&0xff,f);

			lgt=sample[i].loopend-sample[i].loopstart;
			if(lgt&1)err++;
			if(lgt>65536)err++;
			fputc(lgt>>9,f);fputc((lgt>>1)&0xff,f);
		}
	}
	if(err){/*e_print("hostile samples!"); this doesn't seem to work */
	err=0;}

	for(i=0;i<128;i++)if(order[i].pattno==0xff)break;
	fputc(i,f); /* orderlgt */

	fputc(127,f); /* magic1 */

	numpat=0;
	for(i=0;i<128;i++)
		{uchar p=order[i].pattno;
		if(p<254){fputc(p,f);
			if(numpat<p)numpat=p;}
		else fputc(0,f);
		}
	numpat++;

	numch=getnumch();
		if(numch<=4){fwrite("M.K.",1,4,f);numch=4;}
		else{fwrite("8CHN",1,4,f);numch=8;}

	for(i=0;i<numpat;i++){
	int r,c;trackcellT*tr[4];
	for(c=0;c<4;c++)tr[c]=gettrack(i,c);

	for(r=0;r<64;r++)
	for(c=0;c<numch;c++){
		int smpnum,period,note; uchar fx,fxb;
		trackcellT*t=&tr[c][r];
		smpnum=(t->ins+1)&0xff;
		note=t->note;
	
		if(note!=0xff){	
			note-=24;
			if(note<0){note=0;err++;}else
			if(note>61){note=61;err++;}
			period=npertab[note];
		}else period=0;
		fputc((smpnum&0xf0)|((period>>8)&0x0f),f);
		fputc(period&0xff,f);
		
		fx=t->fx;fxb=t->fxb;

		err+=convertfx(&fx,&fxb,TARG_MOD);

		if(fx>='A')fx-='A'-0xa;else
		if(fx>='0')fx-='0';else{
			if(fx==0xff)err++;
			fx=fxb=0;}

		if(t->vol!=0xff){
			if(fx|fxb)err++;
			fx=0xc;fxb=t->vol;
		}
		fputc(((smpnum<<4)&0xf0)|(fx&0x0f),f);
		fputc(fxb,f);
	}
	}

	if(err){e_print("hostile patterns!");
	err=0;}

	for(i=0;i<31;i++)if(sample[i].length)
		fwrite(sample[i].data,2,sample[i].length>>1,f);
		
	e_print("written: protracker module");
}

void myfputc(uchar c,FILE*f)
{
	if(f!=NULL)fputc(c,f);
}

int write_s3m_pattern(FILE*f,int pat)
{
	int i,j,co=64;
	trackcellT*tr[32];

	/* kaytakoon lapi vain detektoituun numch:iin asti*/
	for(i=0;i<32;i++)tr[i]=gettrack(pat,i);

	for(j=0;j<64;j++){
	for(i=0;i<32;i++){
	trackcellT*t=&tr[i][j];uchar c;
		if((t->note!=0xff)||(t->ins!=0xff))c=32;else c=0;
		if(t->vol!=0xff)c|=64;
		if((t->fx!='0')||(t->fxb!=0))c|=128;
		if(c){myfputc(c|i,f);co++;
		if(c&32){
			co+=2;
			if(t->note!=0xff)
				myfputc(((t->note/12)<<4)|(t->note%12),f);
			else myfputc(0xff,f);
			myfputc((t->ins+1)&0xff,f);}
		if(c&64){myfputc(t->vol,f);co++;}
		if(c&128){
			uchar fx=t->fx,fxb=t->fxb;
			convertfx(&fx,&fxb,TARG_S3M);
			if(fx=='0')fx=0;else fx-=('a'-1);
			myfputc(fx,f);
			myfputc(fxb,f);
			co+=2;}
		}
	}
	myfputc(0,f);
	}

	return co;
}

void write_s3m(FILE*f)
{
	struct{
		int songlgt,numinst,numpat;
	}inf;

	{int i=0;inf.songlgt=1;inf.numpat=0;inf.numinst=0;
	for(i=0;i<MAXORDER-2;i++){
		inf.songlgt++;
		if(order[i].pattno==0xff)break;
		if(order[i].pattno>inf.numpat)inf.numpat=order[i].pattno;
	}
	inf.numpat++;
	for(i=0;i<MAXSMPS;i++)
		if(sample[i].format!='0')inf.numinst=i+1;
	}

/* header */
	fwrite(songinfo.name,1,28,f);
	fwrite("\x1a\x10\0\0",1,4,f);

	fputle2(inf.songlgt,f);
	fputle2(inf.numinst,f);
	fputle2(inf.numpat,f);

	fwrite("\0\0\x20\x13\2\0SCRM",1,10,f);

	fputc(songinfo.globvol,f);
	fputc(songinfo.initspd,f);
	fputc(songinfo.inittmp,f);
	fputc(0x30|(songinfo.stereo<<7),f);

	fwrite("\x10\xfc\0\0\0\0\0\0\0\0\0\0",1,12,f);

/* chaninfo */
	{int i=0,foo=0;
	for(;i<32;i++){ /* a bad kludge */
		uchar c;
		if(chaninfo[i].enabled){
			c=(chaninfo[i].panning)&8;
			if(!songinfo.stereo)if(i&1)c^=8;
			c|=(foo&7);
			if(i&1)foo++;
		}else c=0xff;
		fputc(c,f);
	}}

/* order */
	{int i=0;
	for(;i<inf.songlgt;i++)
		fputc(order[i].pattno,f);
	}

	{
	int ptr=inf.songlgt+32+0x40  +(inf.numinst+inf.numpat)*2+32;

/* pointers */
	{int alig=(16-(ptr&15))&15,i=0;
	ptr+=alig;

	for(;i<inf.numinst;i++){
		fputle2(ptr>>4,f);
		ptr+=0x50;
	}
	for(i=0;i<inf.numpat;i++){
		fputle2(ptr>>4,f);
		ptr+=2+write_s3m_pattern(NULL,i);
		ptr=(ptr+0xf)&~0xf;
	}
	for(i=0;i<32;i++)fputc(chaninfo[i].panning,f);
	for(i=alig;i;i--)fputc(0x80,f);
	}

/* samples */
	{int i=0;
	for(;i<inf.numinst;i++){
		fwrite("\1autoexec.bat",1,13,f);

		fputc(ptr>>20,f);fputle2(ptr>>4,f);
		ptr+=(sample[i].length+15)&~0xf;

		fputle4(sample[i].length,f);
		fputle4(sample[i].loopstart,f);
		fputle4(sample[i].loopend,f);
		fputc(sample[i].volume,f);
		fputle2(0,f);
		fputc(sample[i].looping&1,f);
		fputle4(sample[i].freq,f);
		fwrite("\0\0\0\0\0\0\0\0\0\0\0\0",1,12,f);
		fwrite(sample[i].name,1,28,f);
		fwrite("SCRS",1,4,f);
	}	}

/* patterns */	
	{int i=0;
	for(;i<inf.numpat;i++){	
		int co,alig;
		fputle2(write_s3m_pattern(NULL,i),f); /* no olkoon noin perkele*/
		co=2+write_s3m_pattern(f,i);
		alig=(co+0xf)&~0xf;for(;co<alig;co++)fputc(0x80,f);
		}
	}
	
/* samples */
	{int i=0;
	for(;i<inf.numinst;i++)
	if(sample[i].length){
		char*s=convsmp(&sample[i],"s");
		int alig=(16-(sample[i].length&15))&15;
		fwrite(s,1,sample[i].length,f);
		free(s);
		for(;alig;alig--)fputc(0x80,f);
	}	}

	}	

	e_print("written: scream tracker 3 module");
}


/*read_oxtm, write_oxtm oxt(00) - dumppaa siis kaiken datan sinne
	oxtm:
		signature: oxtm
		version (byte):
	songinfo
	orderlist
	patterns
	samples

	oxtc:
		signature: oxtc
		version (byte): 0
		clipboardin tyyppi ja sislt
*/
