#include <signal.h>
#include "oxt.h"

/*** traps ***/

void trapsignals();

void cleanup(int i)
{
	plr_close();
	clear();
	echo();
	if(i)printf("guru meditation %.8x\n",i);
	exit(i);
}

extern int e_broken;
void quitkeyhandler(int i)
{
	trapsignals();
	e_broken++; /* kludge */
}

void trapsignals()
{
	signal(SIGTERM,&cleanup);
	signal(SIGINT,&quitkeyhandler);
	signal(SIGQUIT,&quitkeyhandler);
	signal(SIGFPE,&cleanup);
	signal(SIGSEGV,&cleanup);
}

void init_oxt()
{
	int i,j;
	for(i=0;i<MAXPATS;i++)
	for(j=0;j<MAXCHNS;j++)trax[i][j].d=NULL;
	for(i=0;i<MAXSMPS;i++)sample[i].data=NULL;
	init_song();
}

/******/

void setup_colors() /* -> handle .oxtrc */
{
	int i=1;

	colAttr[colTracks]=WA_NORMAL;

	init_pair(i,COLOR_WHITE,COLOR_BLUE);
	colAttr[colTracksBeat]=COLOR_PAIR(i++);

	colAttr[colMarked]=WA_REVERSE;

	init_pair(i,COLOR_CYAN,COLOR_BLACK);
	colAttr[colMessages]=COLOR_PAIR(i++)|WA_BOLD;

	init_pair(i,COLOR_YELLOW,COLOR_RED);
	colAttr[colColTitles]=COLOR_PAIR(i++)|WA_BOLD;
/*	colAttr[colColTitles]=WA_REVERSE; */
	
	init_pair(i,COLOR_WHITE,COLOR_BLUE);
	colAttr[colTitlebar]=COLOR_PAIR(i++)|WA_BOLD;
}

WINDOW*mainw;
void setup_screen() /* -> ui.c ? */
{
	mainw=initscr();
	start_color();
	cbreak();noecho();

	w=subwin(mainw,getmaxy(mainw)-5,getmaxx(mainw),4,0);
	w1=subwin(mainw,5,getmaxx(mainw),0,0);
	scrollok(w,TRUE);
	keypad(w,TRUE);

	setup_colors();
}

void rmarg(int*argc,char**argv,int n)
{
	while(n<*argc){argv[n]=argv[n+1];n++;}
	(*argc)--;
}

void showhelp()
{
	printf(
	"ocsatracker "OXT_VERSION"\n\n"
	"usage: oxt [MODULEFILE] [-dDRIVER] [-fFREQ]\n\n"
	"drivers\n"
	"  -dn     nosound\n"
	#ifdef HAVE_OSSDSP
	"  -dd     oss /dev/dsp\n"
	#endif
	);

	exit(0);
}

int main(int argc,char*argv[])
{
	init_oxt();

	setup_screen();

	{int i=1;
	for(;i<argc;i++){
		if(argv[i][0]!='-'){read_song(argv[i]);rmarg(&argc,argv,i);}
		else
			if((!strcmp(argv[i],"--help"))||(argv[i][1]=='h'))showhelp();
	}}

	e_resort_columns();

	trapsignals();

	plr_init(&argc,argv);

	e_editor();
	
	cleanup(0);
	return 0;
}
