#define __SONG_C

#include "oxt.h"

trackcellT*gettrack(int patt,int chan)
{
	if(trax[patt][chan].d==NULL){
		trackcellT*d=trax[patt][chan].d=
			malloc(sizeof(trackcellT)*trax[patt][chan].lgt);
		int i=trax[patt][chan].lgt;
		for(;i;i--)*d++=trackcellDFLT;
	}
	return trax[patt][chan].d;
}

void packtrack(int patt,int chan)
{
	trackcellT*d=trax[patt][chan].d;int i;
	if(d==NULL)return;
	for(i=trax[patt][chan].lgt;i;i--){
		if(memcmp(d,&trackcellDFLT,sizeof(trackcellT)))return;
		d++;}
	free(trax[patt][chan].d);
	trax[patt][chan].d=NULL;
}

int getnumch()
{
	int p,c,numch=0;
	for(p=0;p<MAXPATS;p++)
	for(c=numch;c<MAXCHNS;c++)
		if(trax[p][c].d!=NULL)numch=c+1;
	if(numch<2)numch=2;
	return numch;
}

int getnumpats()
{
	int i,numpats=0;
	for(i=0;i<MAXORDER;i++){
		if(order[i].pattno==0xff)break;else
		if(order[i].pattno>=numpats)numpats=order[i].pattno+1;
	}
	return numpats;
}

void pack_all()
{
	int p,c,numch=getnumch(),numpats=getnumpats();
	{int tmp=e_getpattern()+1;if(tmp>numpats)numpats=tmp;}
	for(p=0;p<numpats;p++)
	for(c=0;c<numch;c++)
		packtrack(p,c);
}

void delete_sample(sampleT*s)
{
	if(s->data!=NULL)free(s->data);
	memcpy(s,&samplecellDFLT,sizeof(samplecellDFLT));
}

void init_tracks()
{
	int i,j;
	for(i=0;i<MAXPATS;i++)
	for(j=0;j<MAXCHNS;j++){
		if(trax[i][j].d!=NULL){free(trax[i][j].d);
		trax[i][j].d=NULL;}
		trax[i][j].lgt=64;
	}
	for(i=0;i<MAXORDER;i++)order[i]=ordercellDFLT;	
	for(i=0;i<MAXCHNS;i++){
		chaninfo[i].enabled=1;
		chaninfo[i].panning=(i&1)?0xf:0;
	}

	songinfo.name[0]='\0';
	songinfo.globvol=songinfo.mastvol=48;/*0x40;*/
	songinfo.initspd=6;
	songinfo.inittmp=0x7d;
	songinfo.stereo=0;
	songinfo.format=FMAT_S3M;
	strcpy(songinfo.fname,"unnamed.s3m");
}

void init_instruments()
{
	int i;
	for(i=0;i<MAXSMPS;i++)delete_sample(&sample[i]);
}

int init_song()
{
	init_tracks();
	init_instruments();
			
	es.oct=2; /* kludge!!! */
	return 1;
}

char*fxs3m2mod="FBDA2134i065mn9pE7EFuvwxyz";
char*fxmod2s3m="jfeghlkr8odbCcst";

int convertfx(uchar*fx,uchar*fxb,int targ)
{
	int i=*fx,o;
	if((i>='a')&&(i<='z')){
		if(targ==1)return 0;else o=fxs3m2mod[i-'a'];
	}else
	if((i>='0')&&(i<='9')){
		if(targ==0)return 0;else{
			if((i=='0')&&(!*fxb))o='0';else o=fxmod2s3m[i-'0'];
		}
	}else
	if((i>='A')&&(i<='F')){
		if(targ==0)return 0;else o=fxmod2s3m[i-'A'+0xa];
	}else return 1;
	*fx=o;
	if((o==i)&&(!o))return 1;
	return 0;
}

void convsmp0(char*d,int i,char*how)
{
	for(;i;i--)*d+++=128;	/* 's'*/
}

char*convsmp(sampleT*s,char*how)
{
	char*ss=malloc(s->length);
	memcpy(ss,s->data,s->length);
	convsmp0(ss,s->length,how);
	return ss;
}

/************************************/

/* module loaders */
int read_mod(FILE*f);
int read_s3m(FILE*f);

/* sample loaders */
int read_raw(sampleT*s,FILE*f);

/* module writers */
void write_mod(FILE*f);
void write_s3m(FILE*f);

void write_sample(sampleT*s,char*fn)
{
	FILE*f;
	if((f=fopen(fn,"wb"))==NULL){e_print("failed to open file");}else{
	
	fwrite(s->data,1,s->length,f);
	e_print("written: raw sample");

	fclose(f);}
}


void read_sample(sampleT*s,char*fn)
{
	FILE*f;int suc=0;
	if((f=fopen(fn,"rb"))==NULL){e_print("failed to open file");}else{
	delete_sample(s);

	if(!(suc|=read_raw(s,f)))
	e_print("unknown format");

	if(suc)
		strncpy(s->name,fn,31);
}}

void read_song(char*fn)
{
	FILE*f;int suc=0;
	if((f=fopen(fn,"rb"))==NULL){e_print("failed to open file");}else{
	if(!(suc|=read_mod(f)))
	if(!(suc|=read_s3m(f)))
	e_print("unknown format");

	if(suc)
		strncpy(songinfo.fname,fn,sizeof(songinfo.fname));

	/* refresh table pointers */
/*	for(i=0;i<tablesize;i++)if(columns[i].celltype==Trackcell){
		columns[i].data=(void*)gettrack(
			columns[i].patt,columns[i].chan);
	}*/
	
	e_resort_columns();
	
	}
}

void write_song(char*fn)
{
	FILE*f;
	if((f=fopen(fn,"wb"))==NULL){e_print("failed to open file");}else{
		int i=strlen(fn)-4;
		if((i>0)&&(fn[i]=='.')){
			if(!strcmp(fn+i,".mod"))songinfo.format=FMAT_MOD;else
			if(!strcmp(fn+i,".s3m"))songinfo.format=FMAT_S3M;/* else cattaa pern exti?*/
		}
		strncpy(songinfo.fname,fn,sizeof(songinfo.fname));
		switch((int)songinfo.format){
			case(FMAT_MOD):write_mod(f);break;
			case(FMAT_S3M):write_s3m(f);break;
		}
		fclose(f);
	}
}
