#include "oxt.h"

void getcoltitle(char*t,columndef*c);

/****************** dRAWiNG ROUTiNES *******************/

int maxx=80;

const char*hexchar="0123456789ABCDEF"; /* mihin tatakaan tarttee? */
void drawhex(int bits,int bin)
{
	char buf[6],*b=buf;
	if(bin==0xff)wprintw(w,"..");else{

	while(bits>=0){
		*b++=hexchar[(bin>>bits)&15];
		bits-=4;
	}
	*b=0;wprintw(w,buf);}
}

const char*notechar0="CCDDEFFGGAAB";
const char*notechar1="-#-#--#-#-#-";
void drawnote(int bin)
{
	char buf[4],*b=buf;
	if(bin==0xff)wprintw(w,"...");else{
	*b++=notechar0[bin%12];
	*b++=notechar1[bin%12];
	*b++=hexchar[bin/12];
	*b=0;wprintw(w,buf);}
}

void drawcell(void*data,int row,int col,const celldef*def,int x,int y)
{
	int i=def->numfields;
	const fielddef*fd=def->fields;

	data+=row*def->memsize;

	if((row>=es.brow0)&&
	   (row<=es.brow1)&&
	   (col>=es.bcol0)&&
	   (col<=es.bcol1))
   	wattrset(w,colAttr[colMarked]);
   	else
   	wattrset(w,colAttr[colTracks]);

	for(;i;i--)
	{
		wmove(w,y,x+fd->loc);
		switch((int)fd->type)
		{
			case(NoteFld):
				drawnote(*((uchar*)(data+fd->memloc))); break;
			case(ByteFld):{
				int d=*((uchar*)(data+fd->memloc));
				if(d==0xff)wprintw(w,"..",d);else wprintw(w,"%.2X",d);
				}
				break;
			case(CharFld):	
				wprintw(w,"%c",*((uchar*)(data+fd->memloc))); break;
			case(IntFld):{
				int d=*((uint*)(data+fd->memloc));
				if(!d)wprintw(w,".....",d);else
				wprintw(w,"%.5X",d);}
				break;
			case(StringFld):{
				char*s=(char*)(data+fd->memloc);int i;

				i=fd->size-strlen(s);
				wprintw(w,"%s",s);  /* nit voisi vhn optailla*/
				if(--i)wprintw(w," ");
				for(;i;i--)wprintw(w,".");
/*				for(;i<fd->size;i++)wprintw(wprintw(w,"%c",((i+row)&4)?'.':' ');*/
			}
		}
		fd++;
	}
}

void drawrow(int col,int row,int y)
{
/*	columndef*cc=&columns[col];*/
	{int x=5;
	columndef*c=&columns[col];

	wmove(w,y,0);
	if(row&3)wattrset(w,colAttr[colTracks]);
	    else wattrset(w,colAttr[colMarked]);
	drawhex(4,row);
	if(row&3)wprintw(w,"  ");else wprintw(w,"--");

	while(col<tablesize){
		if(row<c->height){
			if(x+c->width>=maxx)break;
			drawcell(c->data,row,col,&celltypes[c->celltype],x,y);
		}
		col++;x+=c->width;/*if(x>maxx)break;*/
		c++;
	}
	es.col9=col-1;
	row++;y++;
	}
}

void drawtable(int col0,int row0,int y,int maxy)
{
	maxx=getmaxx(w);
	for(;y<=maxy;y++)drawrow(col0,row0++,y);
}

void drawheadframe(int col0)
{
	int i,x=5;columndef*c=&columns[col0];
	
	maxx=getmaxx(w);	
	wmove(w1,3,0);wclrtoeol(w1);
	wattrset(w1,colAttr[colColTitles]);
	wprintw(w1,"row");
	for(i=col0;i<tablesize;i++){
		if(x+c->width<maxx){
		wmove(w1,3,x);
		getcoltitle(c->title,c);
		wprintw(w1,c->title);}else break;
		x+=c->width;
		c++;
		}
	wmove(w1,0,0);wclrtoeol(w1);
	updateheadframe();
}

char*upbar=NULL,*bartmp;
void updateheadframe()
{
/*	static char *upbar=NULL,*tmp;*/
	int i;
	char shab[4]="--==";

	if(upbar==NULL){
		wrefresh(w1);
		upbar=malloc((maxx+2)*sizeof(char));
		bartmp=malloc((maxx+2)*sizeof(char));
	}

	for(i=0;i<maxx;i++)upbar[i]=shab[i&3];
	sprintf(bartmp," oxt " OXT_VERSION ": %s ",songinfo.fname);
	memcpy(upbar,bartmp,strlen(bartmp)*sizeof(char));
	sprintf(bartmp," %c [C-%X %.2X]",
		es.playing?'p':' ',es.oct,es.inst);
	memcpy(upbar+(maxx-strlen(bartmp)-1)*sizeof(char),bartmp,
		(1+strlen(bartmp))*sizeof(char));

	wattrset(w1,colAttr[colTitlebar]);	
	wmove(w1,0,0);/*wprintw(w1,"oidsauosidguosdguo");*/
	wprintw(w1,"%s",upbar);
	wrefresh(w1);
}

void getcoltitle(char*t,columndef*c)
{
	switch((int)c->celltype){
		case(Trackcell):
			sprintf(t,"%X.%X",c->patt,c->chan);
			break;
		case(Ordercell):strcpy(t,"order");break;
		case(Samplecell):
			strcpy(t,"4l lngth loop  end   freq  vl name");break;
		default:strcpy(t,"?");
	}
}

/************************* sCROLLiNGS ETC *********************/

int highestvisiblech()
{
	int i=0,sofar=0;
	for(i=0;i<tablesize;i++)
		if(columns[i].celltype==Trackcell){
		if(columns[i].chan>sofar)sofar=columns[i].chan;
		}
	return sofar;
}

void e_mvcrs(int upd)  /* what a terrible piece of code :) */
{
	const celldef*f;
	int maxy=getmaxy(w)-1;
	
	if(es.colschanged){drawheadframe(es.col0);es.colschanged=0;}

	if(es.worthredraw){upd=4;es.worthredraw=0;}
do{
	upd&=15;
	{
	static int nfld=5,nchr=1;

	if(es.row<0)es.row=0;
	if(es.row>=columns[es.col].height)es.row=columns[es.col].height-1;

	if(es.chr>=nchr){es.chr=0;es.fld++;}
	if(es.fld>=nfld){es.fld=0;es.col++;}
	
	if(es.chr<0){es.chr=99;es.fld--;}
	if(es.fld<0){es.fld=99;es.col--;}

	if(es.col<0){es.col=es.fld=es.chr=0;}
	if(es.col>tablesize-1){
		if((es.col==tablesize)&&(tablesize!=MAXCOLS)){
			es.col--;
			setcol(tablesize++,Trackcell,e_getpattern(),highestvisiblech()+1);
			es.col++;
			es.col9++;
			drawheadframe(es.col0);
			if(upd<2)upd=2;
		}else{
			es.col=tablesize-1; 
			es.fld=es.chr=99;
		}
	}

	f=&celltypes[columns[es.col].celltype];

	nfld=f->numfields;
	
	if(es.fld==99)es.fld=nfld-1;	
	nchr=f->fields[es.fld].size;

	if(es.chr==99)es.chr=nchr-1;

	/* scrollingz */

	if(es.row<0)es.row=0;

	if(es.row<es.row0)while(es.row<es.row0){
		wmove(w,0,0);winsertln(w);es.row0--;
		drawrow(es.col0,es.row0,0);
	}
	if(es.row>es.row0+maxy)while(es.row>es.row0+maxy){
		wmove(w,0,0);wdeleteln(w);es.row0++;
		drawrow(es.col0,es.row0+maxy,maxy);
	}

	}

	{int x=5,y=es.row-es.row0,i=es.col0;
		if(i<es.col) while(i<es.col)x+=columns[i++].width; else
		             while(i>es.col)x-=columns[--i].width;
/*		if(es.col9==99){
			int x=5,i=0;
			while((x<maxx)&&(i<tablesize))x+=columns[i++].width;
			es.col9=i-1;
			upd|=16;
		}*/
		
		if(upd==1)drawcell(columns[es.col].data,es.row,es.col,
			&celltypes[columns[es.col].celltype],x,y);
	
		x+=f->fields[es.fld].loc+es.chr;		
		switch((int)f->fields[es.fld].type){
			case(NoteFld):es.mode=em_Notes;break;
			case(ByteFld):case(IntFld):es.mode=em_Numeric;break;
			case(CharFld):case(StringFld):es.mode=em_Text;break;
			}
		
		if(es.col>es.col9)
			{es.col0++;es.col9=99;upd=4|16;}else
		if(x<5){es.col0--;upd=4|16;}else{
			if(upd>1){
				if(upd>=3){wclear(w);
				if(upd>=4)drawheadframe(es.col0);}
				drawtable(es.col0,es.row0,0,maxy);
				upd=0;
			}	
/*		updateheadframe();*/
		wmove(w,y,x);
		}
	}

}while(upd&16);
}

/***************************** kEYBOARD cOMMANDS ****************/

int e_ismsg=0,e_broken=0;
int e_getch(WINDOW*ww)
{
   int c;
   doupdate();
   
	if(e_broken){c=3;e_broken=0;}else
   c=wgetch(ww);

   if(e_ismsg){
      wmove(w1,1,0);
      wclrtoeol(w1);
      wrefresh(w1);
      e_ismsg=0;
   }
   return c;
}

void e_print(char*s) /* => drawmsg, printf */
{
	if(e_ismsg){
		wmove(w1,1,e_ismsg+2);
		wprintw(w1,"-more-");
		e_getch(w1);
	}
	wmove(w1,1,0);
	wattrset(w1,colAttr[colMessages]);
	wprintw(w1,s);
	wrefresh(w1);
	e_ismsg=strlen(s);
}

void e_getstring(char*s,int lgt)
{
	wmove(w1,2,0);
	wattrset(w1,colAttr[colMessages]);
	echo();
	wgetnstr(w1,s,lgt);
	noecho();
	wmove(w1,1,0);wclrtoeol(w1);e_ismsg=0;
	wmove(w1,2,0);wclrtoeol(w1);
}

char*e_getfilename() /* add: directory browser */
{
	static char fntemp[80];
	e_print("enter filename:");
	e_getstring(fntemp,80);
	return fntemp;
}


/*
	.oxtrc format:
		1 cmd per line: keyname + cmds

	e_getcmd();	  if macros => get int from macrostruc; else get&hndle key
	e_getch();    if macros => get int from mstruc; else get key
	e_getstring();if macros => get ints+zero from mstruc; else getstring
	e_print();    if macros => override; else print
	e_error();    print always
*/

int e_getcmd() /* => handle as defined in .oxtrc */
{
	static int lc;
	int c=0;

	c=e_getch(w);
	switch((int)c){
		case(3):e_print("quit y)es n)o / clear t)racks i)nsts a)ll");wrefresh(w1);
			switch(e_getch(w1)){
				case('y'):return lc=cQuit;
				case('t'):return lc=cClearTracks;
				case('i'):return lc=cClearInsts;
				case('a'):return lc=cClearSong;
			}break;

		case(KEY_UP):return lc=cUp;
		case(KEY_DOWN):return lc=cDown;
		case(KEY_RIGHT):return lc=cRight;
		case(KEY_LEFT):return lc=cLeft;
		case(KEY_PPAGE):return lc=cUp16;
		case(KEY_NPAGE):return lc=cDown16;
		case(KEY_HOME):return lc=cTop;
		case(KEY_END):return lc=cBottom;
		case(KEY_IC):case(KEY_IL):return lc=cInsOne;
		case(KEY_DC):case(KEY_DL):return lc=cDelOne;

		case(21):return lc=cUp16; /* ^U */
		case(22):return lc=cDown16; /* ^V */

		case('\t'):return lc=cNextField;
		case(0xc):return lc=cRedraw;
		case('*'):return lc=cNextOctave;
		case('/'):return lc=cPrevOctave;
		case('<'):return lc=cPrevInst;
		case('>'):return lc=cNextInst;

		case(KEY_BACKSPACE):case('\b'):
			if(es.mode&em_Text)return lc=cChar|0xff;break;

		case(0x0a):return lc=cJump; /* ^J */
		case(KEY_F(1)):return lc=cJumptoOrder;
		case(KEY_F(2)):return lc=cResortColumns;
		case(KEY_F(3)):return lc=cJumptoSamples;
		case(KEY_F(5)):return lc=cPlaySong;
		case(KEY_F(6)):return lc=cPlayPattern;
		case(KEY_F(8)):return lc=cPlayStop;

		case(0x10):/*muualle*/
			e_print("play ^p/s=song/stop p=pattern / 0..f=(un)mute channel");
			for(;;){
				c=e_getch(w1);

				if(c=='p')return lc=cPlayPattern;else
				if(c==0x10)return lc=es.playing?cPlayStop:cPlaySong;
				else
				if(c=='s')return lc=cPlaySong;
				else
				if((c>='0')&&(c<='9')){chaninfo[c-'0'].enabled^=1;}
				else
				if((c>='a')&&(c<='f')){chaninfo[c-'a'+0xa].enabled^=1;}
				else break;

				{char s[MAXCHNS*3+8];int i; /* MAXCHNS => getnumch(); */
				memcpy(s,"muted:",7);
				for(i=0;i<MAXCHNS;i++)if(!chaninfo[i].enabled)
					sprintf(s,"%s %x",s,i);
				e_print(s);
				}
			}
		break;
		case(0x2): return lc=cProcess; /* ^B */


/*		case(0x12):return lc=cLoadSong;
		case(0x17):return lc=cSaveSong;
*/
		case(27):
			c=e_getch(w);
			switch((int)c){
				case('O'):c=e_getch(w); /* curses ei tajua naita */
					switch((int)c){
						case('w'):return lc=cTop;
						case('q'):return lc=cBottom; 
						case('x'):return lc=cUp;
						case('r'):return lc=cDown;
						case('t'):return lc=cLeft;
						case('v'):return lc=cRight;
						case('y'):return lc=cUp16;
						case('s'):return lc=cDown16;
						case('p'):return lc=cInsOne;
						case('l'):return lc=cDelOne;
						case('k'):return lc=cNextPattern;
						case('m'):return lc=cPrevPattern;
						case('o'):return lc=cPrevOctave;
						case('j'):return lc=cNextOctave;
						}
				break;
				case('\t'):return lc=cPrevField;							
				case('b'):return lc=cBeginBlock;
				case('e'):return lc=cEndBlock;
				case('c'):return lc=cCopyBlock;
				case('p'):return lc=cPasteBlock;
				case('u'):return lc=cUnmarkBlock;
				case('z'):
					e_print("clear z=all fields x=this field / "
					        "fill c=all fields v=this field");
					for(;;){	c=e_getch(w1); if(c!=27)break; }
					switch((int)c){
						case('z'):return lc=cClearAll;
						case('x'):return lc=cClearThis;
						case('c'):return lc=cFillAll;
						case('v'):return lc=cFillThis;
						default:e_print("cancelled");break;
					}
					break;
				case('l'):
					if(lc==cMarkEntireColumn)
						return lc=cMarkEntireTable;else
						return lc=cMarkEntireColumn;
			}
			break;

		case(11):
			c=e_getch(w);
			switch((int)c){
				case('b'):return lc=cBeginBlock;
				case('k'):
				case('e'):case(11):return lc=cEndBlock;
				case('c'):return lc=cCopyBlock;
				case('p'):return lc=cPasteBlock;
				case('u'):return lc=cUnmarkBlock;
				case('y'):return lc=cClearAll;
			}break;

		case(6):return lc=cFileFuncs;

		/* trackeditor */
		case('+'):return lc=cNextPattern;
		case('-'):return lc=cPrevPattern;
		
		
	}

	lc=cUnknown;
	if(es.mode&em_Notes)
	switch((int)c){
		case('z'):return cNote;
		case('s'):return cNote+1;
		case('x'):return cNote+2;
		case('d'):return cNote+3;
		case('c'):return cNote+4;
		case('v'):return cNote+5;
		case('g'):return cNote+6;
		case('b'):return cNote+7;
		case('h'):return cNote+8;
		case('n'):return cNote+9;
		case('j'):return cNote+10;
		case('m'):return cNote+11;				
		case('q'):return cNote+12;
		case('2'):return cNote+13;
		case('w'):return cNote+14;
		case('3'):return cNote+15;
		case('e'):return cNote+16;
		case('r'):return cNote+17;	
		case('5'):return cNote+18;	
		case('t'):return cNote+19;	
		case('6'):return cNote+20;	
		case('y'):return cNote+21;	
		case('7'):return cNote+22;	
		case('u'):return cNote+23;	
		case('i'):return cNote+24;	
		case('9'):return cNote+25;	
		case('o'):return cNote+26;	
		case('0'):return cNote+27;
		case('p'):return cNote+28;
		case('.'):return cNote+0xff;
		case(' '):return cNote+0xff;
		case('Q'):return cInst;
		case('W'):return cInst+1;
		case('E'):return cInst+2;
		case('R'):return cInst+3;
		case('T'):return cInst+4;
		case('Y'):return cInst+5;
		case('U'):return cInst+6;
		case('I'):return cInst+7;
		case('O'):return cInst+8;
		case('P'):return cInst+9;
	}
	if(es.mode&em_Numeric)
	{
		if(c=='.')return cNumeric+0xff;
		if(c==' ')return cNumeric+0xff;
		if((c>='0')&&(c<='9'))return cNumeric+c-'0';
		if((c>='a')&&(c<='f'))return cNumeric+c+10-'a';
		if((c>='A')&&(c<='F'))return cNumeric+c+10-'A';
	}

	if((es.mode&em_Text)&&(c>=' ')&&(c<127))return cChar|c;else
	
/*	fprintf(stderr,"UNKNOWN => %i <=\n",c);	*/
	return cUnknown;
}
